package de.urszeidler.eclipse.callchain.diagram.part;

import org.eclipse.core.runtime.Platform;
import org.eclipse.emf.ecore.EAnnotation;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.gmf.runtime.notation.Diagram;
import org.eclipse.gmf.runtime.notation.View;

import de.urszeidler.eclipse.callchain.AM3_Generator;
import de.urszeidler.eclipse.callchain.Artifact;
import de.urszeidler.eclipse.callchain.AtlLibary;
import de.urszeidler.eclipse.callchain.AtlRes;
import de.urszeidler.eclipse.callchain.Call;
import de.urszeidler.eclipse.callchain.CallchainPackage;
import de.urszeidler.eclipse.callchain.Calls;
import de.urszeidler.eclipse.callchain.Comment;
import de.urszeidler.eclipse.callchain.EMF_Generator;
import de.urszeidler.eclipse.callchain.GMF_Generator;
import de.urszeidler.eclipse.callchain.Generic_Generator;
import de.urszeidler.eclipse.callchain.Model;
import de.urszeidler.eclipse.callchain.TopcasedGenerator;
import de.urszeidler.eclipse.callchain.Useit_Generator;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.AM3_GeneratorEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.AM3_GeneratorKindEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.AM3_GeneratorNameEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.ArtifactEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.ArtifactNameEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.ArtifactUriEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.AtlLibaryEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.AtlLibaryNameEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.AtlLibaryUriEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.AtlResEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.AtlResNameEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.AtlResUriEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.CallEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.CallNameEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.CallsEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.CommentDocEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.CommentEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.EMF_GeneratorEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.EMF_GeneratorKindEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.EMF_GeneratorNameEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.GMF_GeneratorEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.GMF_GeneratorKindEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.GMF_GeneratorNameEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.Generic_GeneratorEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.Generic_GeneratorNameEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.MMAliasAliasNameEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.MMAliasEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.MMEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.MMHandlerEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.MMNameEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.MMUriEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.ModelAliasAliasNameEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.ModelAliasEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.ModelEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.ModelNameEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.ModelUriEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.TopcasedGeneratorEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.TopcasedGeneratorKindEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.TopcasedGeneratorNameEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.Useit_GeneratorEditPart;
import de.urszeidler.eclipse.callchain.diagram.edit.parts.Useit_GeneratorNameEditPart;
import de.urszeidler.eclipse.callchain.diagram.expressions.CallchainAbstractExpression;
import de.urszeidler.eclipse.callchain.diagram.expressions.CallchainOCLFactory;

/**
 * This registry is used to determine which type of visual object should be
 * created for the corresponding Diagram, Node, ChildNode or Link represented
 * by a domain model object.
 * 
 * @generated
 */
public class CallchainVisualIDRegistry {

	/**
	 * @generated
	 */
	private static final String DEBUG_KEY = "de.urszeidler.eclipse.callchain.diagram/debug/visualID"; //$NON-NLS-1$

	/**
	 * @generated
	 */
	private static CallchainAbstractExpression Model_2015_Constraint;

	/**
	 * @generated
	 */
	private static CallchainAbstractExpression AtlRes_2016_Constraint;

	/**
	 * @generated
	 */
	private static CallchainAbstractExpression Call_2017_Constraint;

	/**
	 * @generated
	 */
	private static CallchainAbstractExpression MM_2018_Constraint;

	/**
	 * @generated
	 */
	private static CallchainAbstractExpression AtlLibary_2019_Constraint;

	/**
	 * @generated
	 */
	private static CallchainAbstractExpression Artifact_2020_Constraint;

	/**
	 * @generated
	 */
	private static CallchainAbstractExpression EMF_Generator_2021_Constraint;

	/**
	 * @generated
	 */
	private static CallchainAbstractExpression Useit_Generator_2022_Constraint;

	/**
	 * @generated
	 */
	private static CallchainAbstractExpression TopcasedGenerator_2023_Constraint;

	/**
	 * @generated
	 */
	private static CallchainAbstractExpression Comment_2024_Constraint;

	/**
	 * @generated
	 */
	private static CallchainAbstractExpression AM3_Generator_2025_Constraint;

	/**
	 * @generated
	 */
	private static CallchainAbstractExpression GMF_Generator_2026_Constraint;

	/**
	 * @generated
	 */
	private static CallchainAbstractExpression Generic_Generator_2027_Constraint;

	/**
	 * @generated
	 */
	public static int getVisualID(View view) {
		if (view instanceof Diagram) {
			if (CallsEditPart.MODEL_ID.equals(view.getType())) {
				return CallsEditPart.VISUAL_ID;
			} else {
				return -1;
			}
		}
		return de.urszeidler.eclipse.callchain.diagram.part.CallchainVisualIDRegistry
				.getVisualID(view.getType());
	}

	/**
	 * @generated
	 */
	public static String getModelID(View view) {
		View diagram = view.getDiagram();
		while (view != diagram) {
			EAnnotation annotation = view.getEAnnotation("Shortcut"); //$NON-NLS-1$
			if (annotation != null) {
				return (String) annotation.getDetails().get("modelID"); //$NON-NLS-1$
			}
			view = (View) view.eContainer();
		}
		return diagram != null ? diagram.getType() : null;
	}

	/**
	 * @generated
	 */
	public static int getVisualID(String type) {
		try {
			return Integer.parseInt(type);
		} catch (NumberFormatException e) {
			if (Boolean.TRUE.toString().equalsIgnoreCase(
					Platform.getDebugOption(DEBUG_KEY))) {
				CallchainDiagramEditorPlugin.getInstance().logError(
						"Unable to parse view type as a visualID number: "
								+ type);
			}
		}
		return -1;
	}

	/**
	 * @generated
	 */
	public static String getType(int visualID) {
		return String.valueOf(visualID);
	}

	/**
	 * @generated
	 */
	public static int getDiagramVisualID(EObject domainElement) {
		if (domainElement == null) {
			return -1;
		}
		if (CallchainPackage.eINSTANCE.getCalls().isSuperTypeOf(
				domainElement.eClass())
				&& isDiagram((Calls) domainElement)) {
			return CallsEditPart.VISUAL_ID;
		}
		return -1;
	}

	/**
	 * @generated
	 */
	public static int getNodeVisualID(View containerView, EObject domainElement) {
		if (domainElement == null) {
			return -1;
		}
		String containerModelID = de.urszeidler.eclipse.callchain.diagram.part.CallchainVisualIDRegistry
				.getModelID(containerView);
		if (!CallsEditPart.MODEL_ID.equals(containerModelID)) {
			return -1;
		}
		int containerVisualID;
		if (CallsEditPart.MODEL_ID.equals(containerModelID)) {
			containerVisualID = de.urszeidler.eclipse.callchain.diagram.part.CallchainVisualIDRegistry
					.getVisualID(containerView);
		} else {
			if (containerView instanceof Diagram) {
				containerVisualID = CallsEditPart.VISUAL_ID;
			} else {
				return -1;
			}
		}
		switch (containerVisualID) {
		case CallsEditPart.VISUAL_ID:
			if (CallchainPackage.eINSTANCE.getModel().isSuperTypeOf(
					domainElement.eClass())
					&& isModel_2015((Model) domainElement)) {
				return ModelEditPart.VISUAL_ID;
			}
			if (CallchainPackage.eINSTANCE.getAtlRes().isSuperTypeOf(
					domainElement.eClass())
					&& isAtlRes_2016((AtlRes) domainElement)) {
				return AtlResEditPart.VISUAL_ID;
			}
			if (CallchainPackage.eINSTANCE.getCall().isSuperTypeOf(
					domainElement.eClass())
					&& isCall_2017((Call) domainElement)) {
				return CallEditPart.VISUAL_ID;
			}
			if (CallchainPackage.eINSTANCE.getMM().isSuperTypeOf(
					domainElement.eClass())
					&& isMM_2018((de.urszeidler.eclipse.callchain.MM) domainElement)) {
				return MMEditPart.VISUAL_ID;
			}
			if (CallchainPackage.eINSTANCE.getAtlLibary().isSuperTypeOf(
					domainElement.eClass())
					&& isAtlLibary_2019((AtlLibary) domainElement)) {
				return AtlLibaryEditPart.VISUAL_ID;
			}
			if (CallchainPackage.eINSTANCE.getArtifact().isSuperTypeOf(
					domainElement.eClass())
					&& isArtifact_2020((Artifact) domainElement)) {
				return ArtifactEditPart.VISUAL_ID;
			}
			if (CallchainPackage.eINSTANCE.getEMF_Generator().isSuperTypeOf(
					domainElement.eClass())
					&& isEMF_Generator_2021((EMF_Generator) domainElement)) {
				return EMF_GeneratorEditPart.VISUAL_ID;
			}
			if (CallchainPackage.eINSTANCE.getUseit_Generator().isSuperTypeOf(
					domainElement.eClass())
					&& isUseit_Generator_2022((Useit_Generator) domainElement)) {
				return Useit_GeneratorEditPart.VISUAL_ID;
			}
			if (CallchainPackage.eINSTANCE.getTopcasedGenerator()
					.isSuperTypeOf(domainElement.eClass())
					&& isTopcasedGenerator_2023((TopcasedGenerator) domainElement)) {
				return TopcasedGeneratorEditPart.VISUAL_ID;
			}
			if (CallchainPackage.eINSTANCE.getComment().isSuperTypeOf(
					domainElement.eClass())
					&& isComment_2024((Comment) domainElement)) {
				return CommentEditPart.VISUAL_ID;
			}
			if (CallchainPackage.eINSTANCE.getAM3_Generator().isSuperTypeOf(
					domainElement.eClass())
					&& isAM3_Generator_2025((AM3_Generator) domainElement)) {
				return AM3_GeneratorEditPart.VISUAL_ID;
			}
			if (CallchainPackage.eINSTANCE.getGMF_Generator().isSuperTypeOf(
					domainElement.eClass())
					&& isGMF_Generator_2026((GMF_Generator) domainElement)) {
				return GMF_GeneratorEditPart.VISUAL_ID;
			}
			if (CallchainPackage.eINSTANCE.getGeneric_Generator()
					.isSuperTypeOf(domainElement.eClass())
					&& isGeneric_Generator_2027((Generic_Generator) domainElement)) {
				return Generic_GeneratorEditPart.VISUAL_ID;
			}
			break;
		}
		return -1;
	}

	/**
	 * @generated
	 */
	public static boolean canCreateNode(View containerView, int nodeVisualID) {
		String containerModelID = de.urszeidler.eclipse.callchain.diagram.part.CallchainVisualIDRegistry
				.getModelID(containerView);
		if (!CallsEditPart.MODEL_ID.equals(containerModelID)) {
			return false;
		}
		int containerVisualID;
		if (CallsEditPart.MODEL_ID.equals(containerModelID)) {
			containerVisualID = de.urszeidler.eclipse.callchain.diagram.part.CallchainVisualIDRegistry
					.getVisualID(containerView);
		} else {
			if (containerView instanceof Diagram) {
				containerVisualID = CallsEditPart.VISUAL_ID;
			} else {
				return false;
			}
		}
		switch (containerVisualID) {
		case ModelEditPart.VISUAL_ID:
			if (ModelUriEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (ModelNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case AtlResEditPart.VISUAL_ID:
			if (AtlResUriEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (AtlResNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case CallEditPart.VISUAL_ID:
			if (CallNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case MMEditPart.VISUAL_ID:
			if (MMHandlerEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (MMUriEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (MMNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case AtlLibaryEditPart.VISUAL_ID:
			if (AtlLibaryUriEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (AtlLibaryNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case ArtifactEditPart.VISUAL_ID:
			if (ArtifactNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (ArtifactUriEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case EMF_GeneratorEditPart.VISUAL_ID:
			if (EMF_GeneratorKindEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (EMF_GeneratorNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case Useit_GeneratorEditPart.VISUAL_ID:
			if (Useit_GeneratorNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case TopcasedGeneratorEditPart.VISUAL_ID:
			if (TopcasedGeneratorKindEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (TopcasedGeneratorNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case CommentEditPart.VISUAL_ID:
			if (CommentDocEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case AM3_GeneratorEditPart.VISUAL_ID:
			if (AM3_GeneratorKindEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (AM3_GeneratorNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case GMF_GeneratorEditPart.VISUAL_ID:
			if (GMF_GeneratorKindEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (GMF_GeneratorNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case Generic_GeneratorEditPart.VISUAL_ID:
			if (Generic_GeneratorNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case CallsEditPart.VISUAL_ID:
			if (ModelEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (AtlResEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (CallEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (MMEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (AtlLibaryEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (ArtifactEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (EMF_GeneratorEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (Useit_GeneratorEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (TopcasedGeneratorEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (CommentEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (AM3_GeneratorEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (GMF_GeneratorEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (Generic_GeneratorEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case ModelAliasEditPart.VISUAL_ID:
			if (ModelAliasAliasNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case MMAliasEditPart.VISUAL_ID:
			if (MMAliasAliasNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		}
		return false;
	}

	/**
	 * @generated
	 */
	public static int getLinkWithClassVisualID(EObject domainElement) {
		if (domainElement == null) {
			return -1;
		}
		if (CallchainPackage.eINSTANCE.getModelAlias().isSuperTypeOf(
				domainElement.eClass())) {
			return ModelAliasEditPart.VISUAL_ID;
		}
		if (CallchainPackage.eINSTANCE.getMMAlias().isSuperTypeOf(
				domainElement.eClass())) {
			return MMAliasEditPart.VISUAL_ID;
		}
		return -1;
	}

	/**
	 * User can change implementation of this method to handle some specific
	 * situations not covered by default logic.
	 * 
	 * @generated
	 */
	private static boolean isDiagram(Calls element) {
		return true;
	}

	/**
	 * @generated
	 */
	private static boolean isModel_2015(Model domainElement) {
		if (Model_2015_Constraint == null) { // lazy initialization
			Model_2015_Constraint = CallchainOCLFactory
					.getExpression(
							"self.oclIsTypeOf( Model )", CallchainPackage.eINSTANCE.getModel()); //$NON-NLS-1$
		}
		Object result = Model_2015_Constraint.evaluate(domainElement);
		return result instanceof Boolean && ((Boolean) result).booleanValue();
	}

	/**
	 * @generated
	 */
	private static boolean isAtlRes_2016(AtlRes domainElement) {
		if (AtlRes_2016_Constraint == null) { // lazy initialization
			AtlRes_2016_Constraint = CallchainOCLFactory
					.getExpression(
							"self.oclIsTypeOf( AtlRes )", CallchainPackage.eINSTANCE.getAtlRes()); //$NON-NLS-1$
		}
		Object result = AtlRes_2016_Constraint.evaluate(domainElement);
		return result instanceof Boolean && ((Boolean) result).booleanValue();
	}

	/**
	 * @generated
	 */
	private static boolean isCall_2017(Call domainElement) {
		if (Call_2017_Constraint == null) { // lazy initialization
			Call_2017_Constraint = CallchainOCLFactory
					.getExpression(
							"self.oclIsTypeOf( Call )", CallchainPackage.eINSTANCE.getCall()); //$NON-NLS-1$
		}
		Object result = Call_2017_Constraint.evaluate(domainElement);
		return result instanceof Boolean && ((Boolean) result).booleanValue();
	}

	/**
	 * @generated
	 */
	private static boolean isMM_2018(
			de.urszeidler.eclipse.callchain.MM domainElement) {
		if (MM_2018_Constraint == null) { // lazy initialization
			MM_2018_Constraint = CallchainOCLFactory
					.getExpression(
							"self.oclIsTypeOf( MM )", CallchainPackage.eINSTANCE.getMM()); //$NON-NLS-1$
		}
		Object result = MM_2018_Constraint.evaluate(domainElement);
		return result instanceof Boolean && ((Boolean) result).booleanValue();
	}

	/**
	 * @generated
	 */
	private static boolean isAtlLibary_2019(AtlLibary domainElement) {
		if (AtlLibary_2019_Constraint == null) { // lazy initialization
			AtlLibary_2019_Constraint = CallchainOCLFactory
					.getExpression(
							"self.oclIsTypeOf( AtlLibary )", CallchainPackage.eINSTANCE.getAtlLibary()); //$NON-NLS-1$
		}
		Object result = AtlLibary_2019_Constraint.evaluate(domainElement);
		return result instanceof Boolean && ((Boolean) result).booleanValue();
	}

	/**
	 * @generated
	 */
	private static boolean isArtifact_2020(Artifact domainElement) {
		if (Artifact_2020_Constraint == null) { // lazy initialization
			Artifact_2020_Constraint = CallchainOCLFactory
					.getExpression(
							"self.oclIsTypeOf( Artifact )", CallchainPackage.eINSTANCE.getArtifact()); //$NON-NLS-1$
		}
		Object result = Artifact_2020_Constraint.evaluate(domainElement);
		return result instanceof Boolean && ((Boolean) result).booleanValue();
	}

	/**
	 * @generated
	 */
	private static boolean isEMF_Generator_2021(EMF_Generator domainElement) {
		if (EMF_Generator_2021_Constraint == null) { // lazy initialization
			EMF_Generator_2021_Constraint = CallchainOCLFactory
					.getExpression(
							"self.oclIsTypeOf( EMF_Generator )", CallchainPackage.eINSTANCE.getEMF_Generator()); //$NON-NLS-1$
		}
		Object result = EMF_Generator_2021_Constraint.evaluate(domainElement);
		return result instanceof Boolean && ((Boolean) result).booleanValue();
	}

	/**
	 * @generated
	 */
	private static boolean isUseit_Generator_2022(Useit_Generator domainElement) {
		if (Useit_Generator_2022_Constraint == null) { // lazy initialization
			Useit_Generator_2022_Constraint = CallchainOCLFactory
					.getExpression(
							"self.oclIsTypeOf( Useit_Generator )", CallchainPackage.eINSTANCE.getUseit_Generator()); //$NON-NLS-1$
		}
		Object result = Useit_Generator_2022_Constraint.evaluate(domainElement);
		return result instanceof Boolean && ((Boolean) result).booleanValue();
	}

	/**
	 * @generated
	 */
	private static boolean isTopcasedGenerator_2023(
			TopcasedGenerator domainElement) {
		if (TopcasedGenerator_2023_Constraint == null) { // lazy initialization
			TopcasedGenerator_2023_Constraint = CallchainOCLFactory
					.getExpression(
							"self.oclIsTypeOf( TopcasedGenerator )", CallchainPackage.eINSTANCE.getTopcasedGenerator()); //$NON-NLS-1$
		}
		Object result = TopcasedGenerator_2023_Constraint
				.evaluate(domainElement);
		return result instanceof Boolean && ((Boolean) result).booleanValue();
	}

	/**
	 * @generated
	 */
	private static boolean isComment_2024(Comment domainElement) {
		if (Comment_2024_Constraint == null) { // lazy initialization
			Comment_2024_Constraint = CallchainOCLFactory
					.getExpression(
							"self.oclIsTypeOf( Comment )", CallchainPackage.eINSTANCE.getComment()); //$NON-NLS-1$
		}
		Object result = Comment_2024_Constraint.evaluate(domainElement);
		return result instanceof Boolean && ((Boolean) result).booleanValue();
	}

	/**
	 * @generated
	 */
	private static boolean isAM3_Generator_2025(AM3_Generator domainElement) {
		if (AM3_Generator_2025_Constraint == null) { // lazy initialization
			AM3_Generator_2025_Constraint = CallchainOCLFactory
					.getExpression(
							"self.oclIsTypeOf( AM3_Generator )", CallchainPackage.eINSTANCE.getAM3_Generator()); //$NON-NLS-1$
		}
		Object result = AM3_Generator_2025_Constraint.evaluate(domainElement);
		return result instanceof Boolean && ((Boolean) result).booleanValue();
	}

	/**
	 * @generated
	 */
	private static boolean isGMF_Generator_2026(GMF_Generator domainElement) {
		if (GMF_Generator_2026_Constraint == null) { // lazy initialization
			GMF_Generator_2026_Constraint = CallchainOCLFactory
					.getExpression(
							"self.oclIsTypeOf( GMF_Generator )", CallchainPackage.eINSTANCE.getGMF_Generator()); //$NON-NLS-1$
		}
		Object result = GMF_Generator_2026_Constraint.evaluate(domainElement);
		return result instanceof Boolean && ((Boolean) result).booleanValue();
	}

	/**
	 * @generated
	 */
	private static boolean isGeneric_Generator_2027(
			Generic_Generator domainElement) {
		if (Generic_Generator_2027_Constraint == null) { // lazy initialization
			Generic_Generator_2027_Constraint = CallchainOCLFactory
					.getExpression(
							"self.oclIsTypeOf( Generic_Generator )", CallchainPackage.eINSTANCE.getGeneric_Generator()); //$NON-NLS-1$
		}
		Object result = Generic_Generator_2027_Constraint
				.evaluate(domainElement);
		return result instanceof Boolean && ((Boolean) result).booleanValue();
	}

}
